world
	New()
		gtGesture_handler = new()

		//Gestures are defined as pairs of coordinates in a 3x3 grid.

		//Starting from left
		gtGesture_handler.AddGesture \
			("-", list(1, 1, 3, 1))

		//Starting from top
		gtGesture_handler.AddGesture \
			("/", list(3, 3, 1, 1))

		//Starting from top
		gtGesture_handler.AddGesture \
			("\\", list(1, 3, 3, 1))

		//Starting from lower left, clockwise
		gtGesture_handler.AddGesture \
			("B", list(1, 1, 1, 3, 3, 3, 1, 2, 3, 1, 1, 1))

		//A less-than sign ("<") also maps to B! This is to demonstrate
		//how gesture names can be "overloaded" if you have the need.
		gtGesture_handler.AddGesture \
			("B", list(3, 3, 1, 2, 3, 1))

		//Starting from top
		gtGesture_handler.AddGesture \
			("C", list(3, 3, 2, 3, 1, 3, 1, 2, 1, 1, 2, 1, 3, 1))

		//Starting from top
		gtGesture_handler.AddGesture \
			("h", list(1, 3, 1, 2, 1, 1, 1, 2, 2, 2, 3, 2, 3, 1))

		//Starting from top
		gtGesture_handler.AddGesture \
			("I", list(1, 3, 1, 1))

		//Starting from top
		gtGesture_handler.AddGesture \
			("J", list(3, 3, 3, 2, 3, 1, 2, 1, 1, 1, 1, 2))

		//Starting from top
		gtGesture_handler.AddGesture \
			("L", list(1, 3, 1, 2, 1, 1, 2, 1, 3, 1))

		//Starting from top center, clockwise
		gtGesture_handler.AddGesture \
			("O", list(2, 3, 3, 3, 3, 2, 3, 1, 2, 1, 1, 1, 1, 2, 1, 3, 2, 3))

		//Starting from top
		gtGesture_handler.AddGesture \
			("S", list(3, 3, 1, 3, 3, 1, 1, 1))

		//Starting from top left
		gtGesture_handler.AddGesture \
			("U", list(1, 3, 1, 2, 1, 1, 2, 1, 3, 1, 3, 2, 3, 3))

		gtGesture_handler.AddReverseGesture("-", "reverse -")

		gtGesture_handler.AddReverseGesture("B", "reverse B")

		gtGesture_handler.AddReverseGesture("C", "reverse C")

		gtGesture_handler.AddReverseGesture("h", "reverse h")

		gtGesture_handler.AddReverseGesture("I", "reverse I")

		gtGesture_handler.AddReverseGesture("J", "reverse J")

		gtGesture_handler.AddReverseGesture("L", "reverse L")

		gtGesture_handler.AddReverseGesture("O", "reverse O")

		gtGesture_handler.AddReverseGesture("S", "reverse S")

		gtGesture_handler.AddReverseGesture("U", "reverse U")

		gtGesture_handler.AddReverseGesture("/", "reverse /")

		gtGesture_handler.AddReverseGesture("\\", "reverse \\")


client
	gtGesture_HandleGesture(gestureName, score)
		mob << "Best match: [gestureName] with score [round(score, 0.01)] (0 = perfect match)."


mob
	Login()
		loc = locate(6, 6, 1)
		spawn(5)
			src << "Available gestures:"

			for(var/gtGesture_gesture/G in gtGesture_handler.gestures)
				src << "  [G.name]"

			src << "\nNote that gestures are direction-sensitive! See the included \
				HTML file, and the gesture templates in demo.dm, for more insight."
			src << "\nAlso note that the gesture may not register if you are still \
				moving the mouse when you release the left mouse button. This is due to \
				the way BYOND handles mouse input. It may be different in future releases."
			src << "\nAlso note that for some gesture definitions, it may be impossible \
				for a player to get a completely perfect match (score = 0). Perfect matches \
				will generally be registered only for gestures containing \
				nothing but horizontal and/or vertical strokes."
			src << "\nAlso note that (as of this writing) the user must halt mouse \
				movement before releasing the mouse button. Otherwise the release \
				will not register with BYOND's MouseUp/MouseDrop functions."
			src << ""


atom/mouse_drag_pointer = 'demo_drag.dmi'


turf/ground
	icon = 'demo_ground.dmi'

